unit Unit1;

interface

uses
  Windows, Messages, Forms, AppEvnts, Classes, Controls, StdCtrls, Buttons,
  ComCtrls, UPassword, ShellApi, SysUtils, Dialogs, psapi, Menus;


  const PROGRAM_NAME = '~s';
  const TITLE = '~s ver1.00';
  const RIM_TYPEKEYBOARD = 1;
  const RIM_TYPEMOUSE = 0;
  const RI_MOUSE_LEFT_BUTTON_DOWN   = $0001;
  const RI_MOUSE_MIDDLE_BUTTON_DOWN = $0010;
  const RI_MOUSE_RIGHT_BUTTON_DOWN  = $0004;
  const RI_MOUSE_WHEEL              = $0400;
  const MUTEX_NAME = '~sMUTEX';

type


  TForm1 = class(TForm)
    ApplicationEvents1: TApplicationEvents;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Label1: TLabel;
    GroupBox2: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    ListView1: TListView;
    ApplicationEvents2: TApplicationEvents;
    GroupBox3: TGroupBox;
    CheckBox1: TCheckBox;
    Label2: TLabel;
    ComboBox1: TComboBox;
    CheckBox2: TCheckBox;
    Edit2: TEdit;
    OpenDialog1: TOpenDialog;
    PopupMenu1: TPopupMenu;
    Exit1: TMenuItem;
    Button3: TButton;
    PopupMenu2: TPopupMenu;
    N1: TMenuItem;
    Delete1: TMenuItem;
    Button4: TButton;
    Label3: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Label4: TLabel;
    Label5: TLabel;
    procedure ApplicationEvents1Message(var Msg: tagMSG;
      var Handled: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure ApplicationEvents2Message(var Msg: tagMSG;
      var Handled: Boolean);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ListView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private 錾 }
    FHide: Boolean;
    FWindows: Array of HWND;
    FWindowCount: Integer;
    FKeyCode: Integer;
    FKeyUp: Boolean;
    FMouseCode: Integer;
    FMouse: DWord;
    FKeyCode2: Array[0..2] of Integer;
    FKeyUp2: Boolean;
    FNeedPassword: Boolean;
    FHookWndProc : Pointer;
    FOriginalProc: Pointer;
    FExceptPrograms: TStringList;
    FExitOrdered: Boolean;
    FClickTick: DWord;
    FClickCount: Integer;
    FDoubleClick: Boolean;
    FMutex: THandle;
    FPrevPos: TPoint;
    procedure ShowWindows;
    procedure HideWindows;
    procedure HookWndProc( var Msg:TMessage );
    function IsExceptProgram(Wnd: HWND): Boolean;
    procedure SaveFile;
    procedure LoadFile;
    procedure AddExceptProgram(FileName: String);
  public
    { Public 錾 }
  end;

  RAWINPUTDEVICE = Record
      usUsagePage: WORD;
      usUsage: WORD;
      dwFlags: DWORD;
      hwndTarget: HWND;
  end;

  RAWINPUTHEADER = Record
    dwType: DWORD;
    dwSize: DWORD;
    hDevice: THandle;
    wParam: WPARAM;
  end;

  RAWKEYBOARD = Record
    MakeCode: WORD;
    Flags: WORD;
    Reserved: WORD;
    VKey: WORD;
    _Message: UINT;
    ExtraInformation: ULONG;
  end;

  RAWMOUSE = Record
    usFlags: WORD;
    ulButtons: ULONG;
    ulRawButtons: ULONG;
    lLastX: Integer;
    lLastY: Integer;
    ulExtraInformation: DWORD;
  end;

  RAWINPUT = Record
    header: RAWINPUTHEADER;
    keyboard:  RAWKEYBOARD;
  end;
  PRAWINPUT = ^RAWINPUT;

  RAWINPUT2 = Record
    header: RAWINPUTHEADER;
    mouse:  RAWMOUSE;
  end;
  PRAWINPUT2 = ^RAWINPUT2;

  function RegisterRawInputDevices(pRawInputDevices: Pointer; uiNumDevices: UINT; cbSize: UINT): BOOL; stdcall; external 'user32.dll';
  function GetRawInputData(hRawInput: THandle; uiCommand: UINT; pData: Pointer; pcbSize: PUINT; cbSizeHeader: UINT): UINT; stdcall; external 'user32.dll';
var
  Form1: TForm1;

implementation

{$R *.dfm}

// ^XNg[̃bZ[WAppEventł͎Ȃ̂ŁAOō
procedure TForm1.HookWndProc( var Msg:TMessage );
var ps: TPoint;
begin
    case Msg.Msg of
        WM_CLOSE: begin
            if CheckBox1.Checked then
            begin
                ShowWindow(Handle, SW_HIDE);
                ShowWindow(Application.Handle, SW_HIDE);

                if not FExitOrdered then
                begin
                    SaveFile;
                    Exit;
                end;
            end;
        end;

        WM_SYSCOMMAND:begin
            if (Msg.WParam and $FFF0) = SC_MINIMIZE then
            begin
                ShowWindow(Handle, SW_HIDE);
                ShowWindow(Application.Handle, SW_HIDE);
                SaveFile;
                Exit;
            end;

        end;

        WM_USER:begin
            case Msg.LParam of
                WM_LBUTTONDOWN:begin
                    Visible := False;
                    ShowWindow(Handle, SW_SHOWNORMAL);
                    Visible := True;
                    SetForegroundWindow(Handle);
                end;

                WM_RBUTTONDOWN:begin
                    GetCursorPos(ps);
                    PopupMenu1.Popup(ps.X, ps.Y);
                end;
            end;
        end;
    end;


    Msg.Result := CallWindowProc(FOriginalProc ,Handle, Msg.Msg, Msg.WParam, Msg.LParam );

end;




procedure SetTaskTray(Wnd: HWND; Enable: Boolean);
var Tip: String;
    ModuleName: Array[0..259]of Char;
    nid: NOTIFYICONDATA;
    shfi: SHFILEINFO;
begin
	Tip := PROGRAM_NAME;

	GetModuleFileName( 0, ModuleName, sizeof(ModuleName) );
	SHGetFileInfo( ModuleName, 0, shfi, sizeof(SHFILEINFO), SHGFI_ICON or SHGFI_SMALLICON );

	nid.cbSize := sizeof(nid);
	nid.Wnd := Wnd;
	nid.uID := 1;
	nid.hIcon := Form1.Icon.Handle;
    lstrcpy(nid.szTip, PChar(Form1.Caption));
	nid.uCallbackMessage := WM_USER;
	nid.uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;

    if (Enable)	then
    begin
        if not Shell_NotifyIcon(NIM_ADD, @nid) then
            Form1.Caption := Inttostr( GetLastError )
    end
	else Shell_NotifyIcon(NIM_DELETE, @nid);


end;

procedure TForm1.ApplicationEvents1Message(var Msg: tagMSG; var Handled: Boolean);
var Data: Array[0..255] of Byte;
    dwSize: Uint;
    raw: PRAWINPUT;
    raw2: PRAWINPUT2;
    NowTick: DWord;
    Flag: Boolean;
    i, j: Integer;
begin
    case Msg.message of
        // WM_INPUT
        255:begin
            dwSize := 256;
            GetRawInputData(THandle(Msg.lParam), $10000003, @Data, @dwSize, sizeof(RAWINPUTHEADER));
            raw := PRAWINPUT(@Data);
            raw2 := PRAWINPUT2(@Data);

            case raw.header.dwType of
                RIM_TYPEKEYBOARD:           // L[{[h
                begin
                    if raw.keyboard._Message = WM_KEYDOWN then
                    begin
                        Flag := False;
                        if (raw.keyboard.VKey = FKeyCode) and FKeyUp then
                        begin
                            Flag := True;
                            FKeyUp := False;

                            if FHide then ShowWindows
                            else HideWindows;
                        end else
                        begin
                            for i := 0 to 2 do
                            begin
                                if raw.keyboard.VKey = FKeyCode2[i] then
                                begin
                                    Flag := True;

                                    for j := 0 to 2 do
                                    begin
                                        if FKeyCode2[j] <> 0 then
                                        begin
                                            if (GetAsyncKeyState(FKeyCode2[j]) and $8000) = 0 then
                                            begin
                                                Flag := False;
                                                Break;
                                            end;
                                        end;
                                    end;

                                    if Flag = True then Break;
                                end;
                            end;

                            if Flag and FKeyUp2 then
                            begin
                                if FHide then ShowWindows
                                else HideWindows;
                                FKeyUp2 := False;
                            end;
                        end;
                    end else if raw.keyboard._Message = WM_KEYUP then
                    begin
                        if raw.keyboard.VKey = FKeyCode then FKeyUp := True
                        else if raw.keyboard.VKey = FKeyCode2[0] then FKeyUp2 := True
                        else if raw.keyboard.VKey = FKeyCode2[1] then FKeyUp2 := True
                        else if raw.keyboard.VKey = FKeyCode2[2] then FKeyUp2 := True;
                    end;
                end;

                RIM_TYPEMOUSE:              // }EX
                begin
                    if (raw2.mouse.ulButtons and FMouseCode) <> 0 then
                    begin
                        NowTick := GetTickCount;
                        if (NowTick - FClickTick > 400) then
                        begin
                            FClickCount := 0;
                        end;

                        Inc(FClickCount);

                        if FMouseCode = RI_MOUSE_WHEEL then
                        begin
                            // XN[
                            if not FDoubleClick and (raw2.mouse.ulButtons < $80000000) then
                            begin
                                if FHide then ShowWindows
                                else HideWindows;
                            end;
                            // XN[
                            if FDoubleClick and (raw2.mouse.ulButtons > $80000000) then
                            begin
                                if FHide then ShowWindows
                                else HideWindows;
                            end;
                        end

                        // _uNbN
                        else if FDoubleClick then
                        begin
                            if (NowTick - FClickTick < 400) and (FClickCount = 2) then
                            begin
                                if FHide then ShowWindows
                                else HideWindows;
                                FClickCount := 0;
                            end;
                        end else
                        // VONbN
                        begin
                            if FHide then ShowWindows
                            else HideWindows;
                        end;

                        FClickTick := GetTickCount;
                    end;
                end;
            end;
        end;
    end;
end;

procedure ShowMsg(Msg: String; Title: String; _Type: Integer);
begin
    MessageBox(GetActiveWindow(), PChar(Msg), PChar(Title), _Type);
end;

procedure TForm1.ShowWindows;
var i: Integer;
begin
    if FWindowCount = 0 then Exit;
    if PasswordDlg.Showing then Exit;

    if FNeedPassword then
    begin
        if PasswordDlg.ShowModal <> mrOk then Exit;

        if PasswordDlg.Password.Text <> Edit2.Text then
        begin
            ShowMsg('pX[hv܂', 'G[', MB_OK);
            Exit;
        end;
    end;

    for i := 0 to FWindowCount - 1 do
    begin
        if not IsExceptProgram(FWindows[i]) then
        begin
            ShowWindowAsync(FWindows[i], SW_SHOWNORMAL);
        end;
    end;

    FHide := False;
    FWindowCount := 0;
end;


function TForm1.IsExceptProgram(Wnd: HWND): Boolean;
var FileName1, FileName2: String;
    tmpStr: Array[0..259]of Char;
    i: Integer;
    hProcess: THandle;
    ProcessId: DWORD;
    hMod: HMODULE;
    dummy: DWORD;
begin
    Result := False;

    GetWindowThreadProcessId( Wnd, @ProcessId);

    hProcess := OpenProcess(PROCESS_QUERY_INFORMATION or PROCESS_VM_READ, FALSE, ProcessId);
    if hProcess = 0 then Exit;

    if(not EnumProcessModules( hProcess, @hMod, sizeof(HMODULE), dummy)) then
    begin
        CloseHandle(hProcess);
        Exit;
    end;

    GetModuleFileNameEx(hProcess, hMod, @tmpStr, sizeof(tmpStr));
    FileName1 := LowerCase(tmpStr);

    CloseHandle(hProcess);

    for i := 0 to ListView1.Items.Count -1 do
    begin
        FileName2 := LowerCase(FExceptPrograms[i]);

        if FileName1 = FileName2 then
        begin
            Result := True;
            Exit;
        end;
    end;
end;

function GetDesktopWindows(var Windows: Array of HWND): Integer;
var Wnd: HWND;
    IngStyle: Integer;
    Count: Integer;
    tmp: Array[0..255] of Char;
begin
    Count := 0;

	Wnd := GetWindow(GetDesktopWindow(), GW_CHILD);

	while (Wnd <> 0) do
    begin
	    if (IsWindow(Wnd))  then
		begin
			if (IsWindowVisible(Wnd)) then
            begin
			    IngStyle := GetWindowLong(Wnd, GWL_STYLE);

				if ((IngStyle and WS_CAPTION) = WS_CAPTION) then
                begin
                    Windows[Count] := Wnd;
                    Inc(Count);
				end else
                begin
                    if (GetWindowText(Wnd, tmp, 255) > 0) then
                    begin
                        if (lstrcmp(@tmp, PChar('X^[g')) <> 0)
                          and (lstrcmp(@tmp, PChar('Program Manager')) <> 0) then
                        begin
                            Windows[Count] := Wnd;
                            Inc(Count);

                        end;
                    end;
                end;
			end;
		end;

		Wnd := GetWindow(Wnd, GW_HWNDNEXT);
    end;


    Result := Count;
end;

procedure TForm1.HideWindows;
    function Find(List: Array of HWND; Wnd: HWND; Count: Integer): Boolean;
    var i: Integer;
    begin
        Result := True;
        for i := 0 to Count -1 do
        begin
            if Wnd = List[i] then Exit;
        end;
        Result := False;
    end;
var i: Integer;
    tmpWindows: Array[0..255] of HWND;
    tmpCount: Integer;
    TargetCount: Integer;
    LoopCount: Integer;
    hFile: THandle;
    ModuleName: Array[0..255]of Char;
    tmpStr: String;
    Sign, Written: DWord;
    Readed: DWord;
    RecordedWindows: Array of HWND;
begin
    FWindowCount := GetDesktopWindows(FWindows);

    if FWindowCount = 0 then Exit;

    // ܂EBhEB̂x݂
    for i := 0 to FWindowCount - 1 do
    begin
        if not IsExceptProgram(FWindows[i]) then
        begin
            ShowWindowAsync(FWindows[i], SW_HIDE);
        end;
    end;

    Application.ProcessMessages;
    LoopCount := 0;

    // 1ł͏ȂEBhÊŁA܂ŌJԂ
    Repeat
        Sleep(100);
        TargetCount := 0;

        tmpCount := GetDesktopWindows(tmpWindows);

        for i := 0 to tmpCount - 1 do
        begin
            if not IsExceptProgram(tmpWindows[i]) then
            begin
                ShowWindowAsync(tmpWindows[i], SW_HIDE);
                Inc(TargetCount);

                if not Find(FWindows, tmpWindows[i], FWindowCount) then
                begin
                    FWindows[FWindowCount] := tmpWindows[i];
                    Inc(FWindowCount);
                end;
            end;
        end;

        Inc(LoopCount);
        if LoopCount > 10 then Break;

    Until TargetCount = 0;

    GetModuleFileName(0, @ModuleName, 255);
    tmpStr := ExtractFileDir(ModuleName);
    SetCurrentDirectory(PChar(tmpStr));



    // XL[t@C̍XV
    Sign := $444E5748;
    hFile := CreateFile(PChar('HWND.dat'), GENERIC_WRITE or GENERIC_READ, 0, NIL, OPEN_EXISTING, 0, 0);

    // t@C
    if hFile = INVALID_HANDLE_VALUE then
    begin
        hFile := CreateFile(PChar('HWND.dat'), GENERIC_WRITE or GENERIC_READ, 0, NIL, CREATE_ALWAYS, 0, 0);
        WriteFile(hFile, Sign, 4, Written, NIL);
        WriteFile(hFile, FWindowCount, 4, Written, NIL);
        WriteFile(hFile, FWindows[0], 4*FWindowCount, Written, NIL);
        CloseHandle(hFile);
    end
    else begin
        // t@Cɂ
        ReadFile(hFile, Sign, 4, Readed, NIL);
        if Sign <> $444E5748 then
        begin
            // sȃt@C ̂܂܏㏑
            CloseHandle(hFile);
            hFile := CreateFile(PChar('HWND.dat'), GENERIC_WRITE or GENERIC_READ, 0, NIL, CREATE_ALWAYS, 0, 0);
            Sign := $444E5748;
            WriteFile(hFile, Sign, 4, Written, NIL);
            WriteFile(hFile, FWindowCount, 4, Written, NIL);
            WriteFile(hFile, FWindows[0], 4*FWindowCount, Written, NIL);
            CloseHandle(hFile);
        end else
        begin
            // t@C V
            ReadFile(hFile, tmpCount, 4, Readed, NIL);
            SetLength(RecordedWindows, tmpCount);
            ReadFile(hFile, RecordedWindows[0], tmpCount * 4, Readed, NIL);

            SetFilePointer(hFile, 4, NIL, FILE_BEGIN);
            Inc(tmpCount, FWindowCount);
            WriteFile(hFile, tmpCount, 4, Written, NIL);

            SetFilePointer(hFile, 0, NIL, FILE_END);
            WriteFile(hFile, FWindows[0], 4*FWindowCount, Written, NIL);
            CloseHandle(hFile);
        end;
    end;

    FHide := True;
end;

procedure TForm1.FormCreate(Sender: TObject);
var device: array [0..1]of RAWINPUTDEVICE;
    i: Integer;
    hMutex: THandle;
    Vis: Boolean;
    ModuleName: Array[0..255]of Char;
    tmpStr: String;
begin

    FHookWndProc := MakeObjectInstance(HookWndProc);
    FOriginalProc :=Pointer(SetWindowLong(Form1.Handle, GWL_WNDPROC, Longint(FHookWndProc ))) ;
    FExceptPrograms := TStringList.Create;

    device[0].usUsagePage := $01;	// L[{[hp̒萔
    device[0].usUsage := $06;		// L[{[hp̒萔
    device[0].dwFlags := $00000100; // ANeBuł擾
    device[0].hwndTarget := Handle;

    device[1].usUsagePage := $01;	// }EXp̒萔
    device[1].usUsage := $02;		// }EXp̒萔
    device[1].dwFlags := $00000100; // ANeBuł擾
    device[1].hwndTarget := Handle;

    SetLength(FWindows, 1024);

    FKeyCode := VK_ESCAPE;

    LoadFile;

    if ( not RegisterRawInputDevices(@device, 2, sizeof(device[0])) )
    then begin
        i := GetLastError;
        ShowMsg('͋@̎擾Ɏs܂' + #13#10 + Format('G[R[h: %d', [i]), 'G[', MB_OK);
        FExitOrdered := True;
        Application.Terminate;
        Exit;
    end;

    SetTaskTray(Handle, True);

    Vis := True;
    for i := 0 to ParamCount do
    begin
        if ParamStr(i) = '-autorun' then
        begin
            Vis := False;

            GetModuleFileName(0, @ModuleName, 255);
            tmpStr := ExtractFileDir(ModuleName);
            SetCurrentDirectory(PChar(tmpStr));

            DeleteFile('HWND.dat');
            Break;
        end;
    end;

    FKeyUp := True;
    FKeyUp2 := True;
    Self.Visible := Vis;
    FMutex := CreateMutex(NIL, FALSE, PChar(MUTEX_NAME));
end;

// L[̕ύXpEBhEvV[W
procedure TForm1.ApplicationEvents2Message(var Msg: tagMSG;
  var Handled: Boolean);
var Str: Array[0..31]of Char;
    Ed: TEdit;
    ActiveWnd: HWND;
begin
    case Msg.message of
        WM_KEYDOWN:
        begin
            Ed := NIL;
            ActiveWnd := Windows.GetFocus;

            if ActiveWnd = Edit1.Handle then
            begin
                Ed := Edit1;
                FKeyCode := Msg.wParam;
            end else if ActiveWnd = Edit3.Handle then
            begin
                Ed := Edit3;
                FKeyCode2[0] := Msg.wParam;
            end else if ActiveWnd = Edit4.Handle then
            begin
                Ed := Edit4;
                FKeyCode2[1] := Msg.wParam;
            end else if ActiveWnd = Edit5.Handle then
            begin
                Ed := Edit5;
                FKeyCode2[2] := Msg.wParam;
            end;

            if Ed <> NIL then
            begin
                GetKeyNameText(Msg.lParam, @Str, Sizeof(Str) );
                Ed.Text := Str;
                Windows.SetFocus(Button3.Handle);
            end;
        end;
    end;

end;



procedure TForm1.CheckBox1Click(Sender: TObject);
var Key: HKEY;
    FileName: Array[0..259] of Char;
    Str: String;
begin
    if CheckBox1.Checked then
    begin
        if RegOpenKeyEx(HKEY_CURRENT_USER, PChar('Software\Microsoft\Windows\CurrentVersion\Run'), 0, KEY_WRITE, Key) <> ERROR_SUCCESS then
        begin
            ShowMsg('WXg̃I[vɎs܂', 'G[', MB_OK);
            CheckBox1.Checked := False;
            Exit;
        end;

        GetModuleFileName(0, @FileName, sizeof(FileName));

        Str := FileName;
        Str := '"' + Str + '" -autorun';
        if RegSetValueEx(Key, PChar(PROGRAM_NAME), 0, REG_SZ, PChar(Str), Length(Str) +1) <> ERROR_SUCCESS then
        begin
            ShowMsg('WXg݂̏Ɏs܂', 'G[', MB_OK);
            RegCloseKey(Key);
            Exit;
        end;

        RegCloseKey(Key);
    end else
    begin
        if RegOpenKeyEx(HKEY_CURRENT_USER, PChar('Software\Microsoft\Windows\CurrentVersion\Run'), 0, KEY_WRITE, Key) <> ERROR_SUCCESS then
        begin
            Exit;
        end;

        RegDeleteValue(Key, PChar(PROGRAM_NAME));

        RegCloseKey(Key);
    end;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
    FNeedPassword := CheckBox2.Checked;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    SaveFile;
    SetTaskTray(Handle, False);
    SetWindowLong(Form1.Handle,GWL_WNDPROC,Longint(FOriginalProc));
    FreeObjectInstance(FHookWndProc);
    FExceptPrograms.Free;
    if (FMutex <> 0) then CloseHandle(FMutex);
end;

procedure TForm1.AddExceptProgram(FileName: String);
var ListItem: TListItem;
begin
    ListItem := ListView1.Items.Add;
    ListItem.Caption := ExtractFileName(FileName);
    ListItem.SubItems.Add( ExtractFileDir(FileName) );
    FExceptPrograms.Add(FileName);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    if not OpenDialog1.Execute then Exit;

    AddExceptProgram(OpenDialog1.FileName);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    if ListView1.ItemIndex < 0 then Exit;

    FExceptPrograms.Delete(ListView1.ItemIndex);
    ListView1.Items.Delete(ListView1.ItemIndex);

end;

procedure TForm1.SaveFile;
    function GetEncryptedPass(var Pass: Array of Byte): Integer;
    var i, len: Integer;
        Str: String;
        v: Byte;
    begin
        Result := 0;
        len := Length(Edit2.text);

        if len = 0 then Exit;

        Str := Edit2.Text;
        Move(Str[1], Pass, len);
        Pass[len] := 0;

        for i := 0 to len do
        begin
            v := Pass[i];
            case i mod 4 of
              0: begin
                v := v xor $3F;     asm Rol v,1 end;
              end;

              1: begin
                v := v xor $CF;     asm Rol v,6 end;
              end;

              2: begin
                v := v xor $1B;     asm Rol v,1 end;
              end;

              3: begin
                v := v xor $BD;     asm Rol v,8 end;
              end;
            end;

            Pass[i] := v
        end;

        Result := len + 1;
    end;

var hFile: THandle;
    Written: DWord;
    Sign: DWORD;
    Version: DWORD;
    Reserve: Array[0..7] of Byte;
    PassSize: Integer;
    Pass: Array[0..254] of Byte;
    ProgramCount: Integer;
    ProgramName: Array[0..259] of Char;
    ProgramNameSize: Integer;
    i: Integer;
    tmpStr: String;
    BackGroung: LongBool;
begin
    GetModuleFileName(0, @ProgramName, 260);
    tmpStr := ExtractFileDir(ProgramName);
    SetCurrentDirectory(PChar(tmpStr));

    hFile := CreateFile(PChar('settings.dat'), GENERIC_WRITE, 0, NIL, CREATE_ALWAYS, 0, 0);

    if (hFile = INVALID_HANDLE_VALUE) then Exit;

    Sign := $58585246;
    Version := 101;
    FillChar(Reserve, sizeof(Reserve), 0);
    BackGroung := CheckBox1.Checked;
    i := Length(Edit1.Text) + 1;
    tmpStr := Edit1.Text;
    FMouse := ComboBox1.ItemIndex;

    WriteFile(hFile, Sign, 4, Written, NIL);                    // VOj`
    WriteFile(hFile, Version, 4, Written, NIL);                 // o[W
    WriteFile(hFile, Reserve, sizeof(Reserve), Written, NIL);     // \

    WriteFile(hFile, FKeyCode, 4, Written, NIL);                // sL[
    WriteFile(hFile, i, 4, Written, NIL);                       // sL[̖O̒ NULL܂
    WriteFile(hFile, tmpStr[1], i - 1, Written, NIL);           // sL[̖O
    WriteFile(hFile, Reserve[0], 1, Written, NIL);              // I[NULL

    tmpStr := Edit3.Text;
    i := Length(Edit3.Text) + 1;
    WriteFile(hFile, FKeyCode2[0], 4, Written, NIL);            // sL[2-1
    WriteFile(hFile, i, 4, Written, NIL);                       // sL[̖O̒ NULL܂
    WriteFile(hFile, tmpStr[1], i - 1, Written, NIL);           // sL[̖O
    WriteFile(hFile, Reserve[0], 1, Written, NIL);              // I[NULL

    tmpStr := Edit4.Text;
    i := Length(Edit4.Text) + 1;
    WriteFile(hFile, FKeyCode2[1], 4, Written, NIL);            // sL[2-2
    WriteFile(hFile, i, 4, Written, NIL);                       // sL[̖O̒ NULL܂
    WriteFile(hFile, tmpStr[1], i - 1, Written, NIL);           // sL[̖O
    WriteFile(hFile, Reserve[0], 1, Written, NIL);              // I[NULL

    tmpStr := Edit5.Text;
    i := Length(Edit5.Text) + 1;
    WriteFile(hFile, FKeyCode2[2], 4, Written, NIL);            // sL[2-3
    WriteFile(hFile, i, 4, Written, NIL);                       // sL[̖O̒ NULL܂
    WriteFile(hFile, tmpStr[1], i - 1, Written, NIL);           // sL[̖O
    WriteFile(hFile, Reserve[0], 1, Written, NIL);              // I[NULL

    WriteFile(hFile, FMouse, 4, Written, NIL);                  // }EX
    WriteFile(hFile, BackGroung, 4, Written, NIL);              // 풓IvV

    PassSize := GetEncryptedPass(Pass);
    WriteFile(hFile, PassSize, 4, Written, NIL);                // pX[hTCY(NULL܂)
    WriteFile(hFile, Pass[0], PassSize, Written, NIL);          // pX[h

    ProgramCount := ListView1.Items.Count;
    WriteFile(hFile, ProgramCount, 4, Written, NIL);            // OvO

    for i := 0 to ProgramCount -1 do
    begin
        ProgramNameSize := Length(FExceptPrograms[i]);
        tmpStr := FExceptPrograms[i];
        Move(tmpStr[1], ProgramName[0], ProgramNameSize);
        ProgramName[ProgramNameSize] := #0;
        Inc(ProgramNameSize);

        WriteFile(hFile, ProgramNameSize, 4, Written, NIL);               // OvOTCY
        WriteFile(hFile, ProgramName[0], ProgramNameSize, Written, NIL);  // OvO
    end;

    CloseHandle(hFile);
end;


procedure TForm1.LoadFile;
    function GetDecryptedPass(var Pass: Array of Byte; len: Integer): Integer;
    var i:  Integer;
        v: Byte;
    begin
        Result := 0;

        if len = 0 then Exit;

        for i := 0 to len do
        begin
            v := Pass[i];
            case i mod 4 of
              0: begin
                asm Ror v,1 end;
                v := v xor $3F;
              end;

              1: begin
                asm Ror v,6 end;
                v := v xor $CF;
              end;

              2: begin
                asm Ror v,1 end;
                v := v xor $1B;
              end;

              3: begin
                asm Ror v,8 end;
                v := v xor $BD;
              end;
            end;

            Pass[i] := v
        end;

        Result := len;
    end;

var hFile: THandle;
    Readed: DWord;
    Sign: DWORD;
    Version: DWORD;
    Reserv: Array[0..7] of Byte;
    PassSize: Integer;
    Pass: Array[0..254] of Byte;
    ProgramCount: Integer;
    ProgramName: Array[0..259] of Char;
    ProgramNameSize: Integer;
    i: Integer;
    tmpStr: String;
    BackGroung: LongBool;
begin
    GetModuleFileName(0, @ProgramName, 260);
    tmpStr := ExtractFileDir(ProgramName);
    SetCurrentDirectory(PChar(tmpStr));

    hFile := CreateFile(PChar('settings.dat'), GENERIC_READ, 0, NIL, OPEN_EXISTING, 0, 0);

    if (hFile = INVALID_HANDLE_VALUE) then Exit;

    ReadFile(hFile, Sign, 4, Readed, NIL);                    // VOj`
    if Sign <> $58585246 then
    begin
        CloseHandle(hFile);
        Exit;
    end;

    ReadFile(hFile, Version, 4, Readed, NIL);                 // o[W
    ReadFile(hFile, Reserv, sizeof(Reserv), Readed, NIL);     // \

    ReadFile(hFile, FKeyCode, 4, Readed, NIL);                // sL[
    ReadFile(hFile, i, 4, Readed, NIL);                       // sL[̖O̒
    ReadFile(hFile, ProgramName, i, Readed, NIL);             // sL[
    Edit1.Text := ProgramName;

    ReadFile(hFile, FKeyCode2[0], 4, Readed, NIL);            // sL[ 2-1
    ReadFile(hFile, i, 4, Readed, NIL);                       // sL[̖O̒
    ReadFile(hFile, ProgramName, i, Readed, NIL);             // sL[
    Edit3.Text := ProgramName;

    ReadFile(hFile, FKeyCode2[1], 4, Readed, NIL);            // sL[ 2-2
    ReadFile(hFile, i, 4, Readed, NIL);                       // sL[̖O̒
    ReadFile(hFile, ProgramName, i, Readed, NIL);             // sL[
    Edit4.Text := ProgramName;

    ReadFile(hFile, FKeyCode2[2], 4, Readed, NIL);            // sL[ 2-3
    ReadFile(hFile, i, 4, Readed, NIL);                       // sL[̖O̒
    ReadFile(hFile, ProgramName, i, Readed, NIL);             // sL[
    Edit5.Text := ProgramName;

    ReadFile(hFile, FMouse, 4, Readed, NIL);                  // }EX
    ReadFile(hFile, BackGroung, 4, Readed, NIL);              // 풓IvV

    Combobox1.ItemIndex := FMouse;
    Self.ComboBox1Change(Self);


    CheckBox1.Checked := BackGroung;
    if BackGroung then CheckBox1Click(Self);

    ReadFile(hFile, PassSize, 4, Readed, NIL);                // pX[hTCY(NULL܂)
    ReadFile(hFile, Pass[0], PassSize, Readed, NIL);          // pX[h
    GetDecryptedPass(Pass, PassSize);
    ProgramName[0] := #0;
    Move(Pass, ProgramName, PassSize);
    Edit2.Text := ProgramName;


    ReadFile(hFile, ProgramCount, 4, Readed, NIL);             // OvO

    for i := 0 to ProgramCount -1 do
    begin

        ReadFile(hFile, ProgramNameSize, 4, Readed, NIL);               // vO
        ReadFile(hFile, ProgramName[0], ProgramNameSize, Readed, NIL);  // vO
        AddExceptProgram(ProgramName);
    end;

    CloseHandle(hFile);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
    FExitOrdered := True;
    Close;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
    Case Combobox1.ItemIndex of
        0:
        begin
            FMouseCode := 0;
            FDoubleClick := False;
        end;

        1:
        begin
            FMouseCode := RI_MOUSE_LEFT_BUTTON_DOWN;
            FDoubleClick := False;
        end;

        2:
        begin
            FMouseCode := RI_MOUSE_LEFT_BUTTON_DOWN;
            FDoubleClick := True;
        end;

        3:
        begin
            FMouseCode := RI_MOUSE_RIGHT_BUTTON_DOWN;
            FDoubleClick := False;
        end;

        4:
        begin
            FMouseCode := RI_MOUSE_RIGHT_BUTTON_DOWN;
            FDoubleClick := True;
        end;

        5:
        begin
            FMouseCode := RI_MOUSE_MIDDLE_BUTTON_DOWN;
            FDoubleClick := False;
        end;

        6:
        begin
            FMouseCode := RI_MOUSE_MIDDLE_BUTTON_DOWN;
            FDoubleClick := True;
        end;

        7:
        begin                                      
            FMouseCode := RI_MOUSE_WHEEL;
            FDoubleClick := False;
            Windows.SetFocus(Button3.Handle);
        end;

        8:
        begin
            FMouseCode := RI_MOUSE_WHEEL;
            FDoubleClick := True;
            Windows.SetFocus(Button3.Handle);
        end;
    end;

end;

procedure TForm1.ListView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if Key = VK_DELETE then
    begin
        Self.Button2Click(Self);
    end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
    Edit1.Text := 'Ȃ';
    FKeyCode := 0;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
    Edit3.Text := 'Ȃ';
    FKeyCode2[0] := 0;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
    Edit4.Text := 'Ȃ';
    FKeyCode2[1] := 0;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
    Edit5.Text := 'Ȃ';
    FKeyCode2[2] := 0;
end;

end.
